\section{Ansible}

\begin{itemize}
	\itemsep -0.2em
	\item Ansible is a DevOps tools where configuration is managed as code, and easily pushed to managed devices
	\item The code is defined in a playbooks, where site specific information is provided using variables
	\item To guarantee the same way of working anywhere, the Ansible playbooks are normally provided thorough git repositories
	\item Using Ansible replaces the need to perform any manual configuration on a individual node. If an engineer is doing some changes manually, it is not a big deal because the next time Ansible is run, the desired state is going to be implemented. The only problem/risk is that the changes made manually are gone and this may have an impact on the system.
\end{itemize}

\subsection{Basics}
Ansible manages assets. The list of asses is saved in a inventory file. There is no risk of conflict because of idempotency. If you run the same playbook again, it should always lead to the same result.

\begin{figure}[h!]
  \center
  \includegraphics[width=0.75\textwidth]{ansible}
  \caption{Ansible Architecture}
\end{figure}

\paragraph{Alternatives} \hfill \\
There are many solutions similar to ansible: Puppet, Chef, SaltStack. Ansible is gaining more and more market share because: can be flexibly extended, Ansible is agentless, supported by RedHat, playbooks are written in YAML.

\subsection{Set-Up}
Ansible has a control node and multiples managed nodes. The Ansible software runs on the control node and managed the python scrips which can be executed on the managed nodes. The managed nodes require remote access as well as Python to be available.

\begin{enumerate}
	\itemsep -0.2em
	\item Create a dedicated user account.
	\item Ensure this user has sudo privileges on at least the managed nodes 
	\item Ensure that SSH based access to the managed nodes has been configured 
	\item Install Python (Python is nowadays available by default on many linux distributions. 
	\item Set up host name resolving - DNS service
	\item Create an inventory file 
	\item Configure the ansible.cfg file
\end{enumerate}

\subsubsection{Service Account}
To manage settings on remote hosts, a dedicated user account is needed. This user account needs to be able to log in to managed hosts, using SSH. Typically, SSH key-based access is used, but other options are possible. To perform admin tasks on the managed hosts, "sudo setup" is required.

\subsubsection{Understanding the Inventory}
Inventory is a file that identifies Ansible managed hosts, in which host groups can be defined. 

\subsection{Commands and Modules}
Thousands of Ansible modules are provided, providing access to a wide range of tasks. Modules are written in Python, and used in ad-hoc commands and Ansible playbooks. Try to avoid the commands: command, shell and raw.

\begin{lstlisting}
ansible-doc -l // get al list of all the modules
\end{lstlisting}

When we run a command with ansible a python script is generated on the control node and the python script is executed through ssh on the managed host.

\subsection{Playbooks}
A playbook contains multiple tasks that are run in order. Idempotency is important in a playbook because if a task fails, the whole play fails. So for example the "command" module should not be used in playbooks. If Ansible doesn't provide a module, the module command is the only way to go. But the ansible way with modules should always be the preferred way. 


In short a playbook is a collection of plays. Each play contains at least one task that uses an Ansible module to get things done. Each play has a header that specifies on which hosts the tasks should be executed. 

\begin{lstlisting}
---
- name: install start and enable httpd
  hosts: all
  tasks: 
  
  // Task in the playbook
  - name: install package
  	yum:
  		name: httpd
  		state: latest
  - name: start and enable service
    service: 
    	name: httpd
    	state: started
    	enabled: yes
\end{lstlisting}

In order to remove or clean up resources a separate playbook has to be written to achieve this goal.

\subsection{Variables}
Using variables makes it possible to separate static code from dynamic code. Using variables makes a playbook portable and usable in different environments. Variables can be provided in multiple ways: as ansible facts, defined in a playbook, defined in inventory, specified as a command line option, using register.

\begin{lstlisting}
---
- name create a user using a variable
  host: ansible1 // ansible fact
  vars:
  	user: mirjam
  tasks:
  	- name: create {{ user }} on host {{ ansible_hostname }}
  	  user: 
  	  	name: "{{ user }}"
\end{lstlisting}



\subsubsection{Facts}
Ansible facts are system variables that contain information about the managed system. Each playbook starts with an implicit task to gather facts. To use fact gathering from an ad-hoc command use the setup module. To disable fact gathering, use gather-facts: no in the play header (to speed up the playbook if fact gathering is not relevant for the tasks).

Facts are store din a multi-valued variable with the name "ansible\_facts", which is organised as a dictionary.

\subsection{Conditionals}

Loops and items allow ansible to process over a list of values.